class Machine
{
    ghost var active: bool;
    var remainig_usages: int;

    predicate Valid()
    reads `remainig_usages;
    {
        0 <= remainig_usages <= 5
    }

    predicate IsActive()
    reads `active
    {
        active == true
    }

    method Init()
    modifies this;
    ensures Valid() && !IsActive();
    {
        active := false;
        remainig_usages := 0;
    }



    method activate()
    modifies this`active, `remainig_usages;
    requires Valid() && !active;
    ensures Valid() && active;
    ensures remainig_usages == 5
    {
        active := true;
        remainig_usages := 5;
    } 

    method deactivate()
    modifies `active;
    requires Valid() && IsActive();
    ensures Valid() && !IsActive();
    {
        active := false;
    }

    method do_something()
    modifies `remainig_usages
    requires Valid() && IsActive();
    requires remainig_usages > 0;
    ensures Valid() && IsActive();
    ensures remainig_usages == old(remainig_usages) - 1;
    {
        print("Hello\n");
        remainig_usages := remainig_usages - 1;
    }
}

method Main()
{
    var m := new Machine;
    m.Init();
    // m.do_something();
    m.activate(); // 5
    m.do_something(); // 4
    m.do_something(); // 3
    m.deactivate();
    m.do_something();
}